<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true">
            <el-form-item label="用户ID" prop="userId">
              <el-input v-model="queryParams.userId" placeholder="请输入用户ID" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="项目ID" prop="projectId">
              <el-input v-model="queryParams.projectId" placeholder="请输入项目ID" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['project:projectRelevancy:add']">新增 </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate()" v-hasPermi="['project:projectRelevancy:edit']"
              >修改
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()" v-hasPermi="['project:projectRelevancy:remove']"
              >删除
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['project:projectRelevancy:export']">导出 </el-button>
          </el-col>
          <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" :data="projectRelevancyList" @selection-change="handleSelectionChange">
        <el-table-column prop="id" label="关联ID" width="180" />
        <el-table-column prop="userId" label="用户ID" width="100" />
        <el-table-column prop="projectId" label="项目ID" width="180" />
        <el-table-column prop="project.projectName" label="项目名称" width="200" />
        <el-table-column prop="project.type" label="项目类型" width="150" />
        <el-table-column prop="project.projectSite" label="项目地址" width="200" />
        <el-table-column prop="project.principal" label="负责人" width="120" />
        <el-table-column prop="project.principalPhone" label="联系电话" width="150" />
        <el-table-column prop="project.onStreamTime" label="上线时间" width="150" />
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-tooltip content="修改" placement="top">
              <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['project:projectRelevancy:edit']"></el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button
                link
                type="primary"
                icon="Delete"
                @click="handleDelete(scope.row)"
                v-hasPermi="['project:projectRelevancy:remove']"
              ></el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>
      <!-- 添加 ShuttleFrame 弹窗 -->
      <el-dialog v-model="shuttleVisible" title="编辑关联项目" width="auto" destroy-on-close>
        <shuttle-frame :userId="selectedUserId" @close="shuttleVisible = false" />
      </el-dialog>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>

    <!-- 添加或修改系统用户与项目关联对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="projectRelevancyFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="用户ID" prop="userId">
          <el-select v-model="form.userId" placeholder="请选择用户">
            <el-option v-for="user in userList" :key="user.userId" :label="user.nickName" :value="user.userId" />
          </el-select>
        </el-form-item>

        <el-form-item label="项目ID" prop="projectId">
          <!-- 项目ID下拉选择框 -->
          <el-select v-model="form.projectId" placeholder="请选择项目ID" @change="onProjectChange">
            <el-option v-for="project in projectList" :key="project.id" :label="project.projectName" :value="project.id" />
          </el-select>
        </el-form-item>
      </el-form>
      <div v-if="selectedProject" style="padding: 0px 100px">
        <p><strong>项目名称:</strong> {{ selectedProject.projectName }}</p>
        <p><strong>项目类型:</strong> {{ selectedProject.type }}</p>
        <p><strong>项目地址:</strong> {{ selectedProject.projectSite }}</p>
        <p><strong>负责人:</strong> {{ selectedProject.principal }}</p>
        <p><strong>联系电话:</strong> {{ selectedProject.principalPhone }}</p>
      </div>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="ProjectRelevancy" lang="ts">
import { addProjectRelevancy, delProjectRelevancy, listProjectRelevancy, updateProjectRelevancy } from '@/api/project/projectRelevancy';
import { listProject } from '@/api/project/project';
import { listUser } from '@/api/system/user';
import { ProjectRelevancyForm, ProjectRelevancyQuery, ProjectRelevancyVO } from '@/api/project/projectRelevancy/types';
import ShuttleFrame from './component/ShuttleFrame.vue';
import { UserVO } from '@/api/system/user/types';
import { ProjectVO } from '@/api/project/project/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const projectRelevancyList = ref<ProjectRelevancyVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const projectRelevancyFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: ProjectRelevancyForm = {
  id: undefined,
  userId: undefined,
  projectId: undefined,
  deletedAt: undefined
};
const data = reactive<PageData<ProjectRelevancyForm, ProjectRelevancyQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    orderByColumn: 'createTime',
    isAsc: 'desc',
    userId: undefined,
    projectId: undefined,
    deletedAt: undefined,
    params: {}
  },
  rules: {
    id: [{ required: true, message: '主键ID不能为空', trigger: 'blur' }],
    userId: [{ required: true, message: '用户ID不能为空', trigger: 'blur' }],
    projectId: [{ required: true, message: '项目ID不能为空', trigger: 'blur' }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询系统用户与项目关联列表 */
const getList = async () => {
  loading.value = true;
  const res = await listProjectRelevancy(queryParams.value);
  projectRelevancyList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  projectRelevancyFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: ProjectRelevancyVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加系统用户与项目关联';
};

const shuttleVisible = ref(false);
const selectedUserId = ref<string | number>();

const handleUpdate = (row?: ProjectRelevancyVO) => {
  const currentRow = row || projectRelevancyList.value.find((item) => item.id === ids.value[0]);
  if (currentRow) {
    selectedUserId.value = currentRow.userId;
    shuttleVisible.value = true;
  }
};

/** 提交按钮 */
const submitForm = () => {
  projectRelevancyFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateProjectRelevancy(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addProjectRelevancy(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: ProjectRelevancyVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除系统用户与项目关联编号为"' + _ids + '"的数据项？').finally(() => (loading.value = false));
  await delProjectRelevancy(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'project/projectRelevancy/export',
    {
      ...queryParams.value
    },
    `projectRelevancy_${new Date().getTime()}.xlsx`
  );
};

const projectList = ref<any[]>([]);
const projectItem = new Map();
const selectedProject = ref<any | null>(null);

// 获取项目列表的方法
const getProjectList = async () => {
  try {
    const res = await listProject();
    const projectListData = res.rows;
    projectList.value = projectListData;

    // 将项目详情存入 Map
    projectListData.forEach((project: ProjectVO) => {
      projectItem.set(project.id, {
        projectName: project.projectName,
        type: project.type,
        projectSite: project.projectSite,
        principal: project.principal,
        principalPhone: project.principalPhone
      });
    });
  } catch (error) {
    console.error('获取项目列表失败:', error);
  }
};

// 当选择项目时触发
const onProjectChange = (projectId: string) => {
  selectedProject.value = projectItem.get(projectId) || null;
};

//获取新增用户列表方法

const userList = ref<{ userId: string | number; nickName: string }[]>([]);
const getUserList = async () => {
  try {
    const response = await listUser({
      pageNum: 1,
      pageSize: 100
    });
    userList.value = response.rows.map((user: UserVO) => ({
      userId: user.userId,
      nickName: user.nickName
    }));
  } catch (error) {
    console.error('获取用户列表失败:', error);
  }
};

onMounted(() => {
  getList();
  getProjectList();
  getUserList();
});
</script>
<style></style>
